<?php

class ModuleTask extends AppModule
{
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'Task';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Work and task management';
    $this->Dependencies = array('User');
  }

  function DoStart()
  {
    $this->System->FormManager->RegisterClass('Task', array(
      'Title' => 'Úkoly',
      'Table' => 'Task',
      'DefaultSortColumn' => 'TimeCreate',
      'DefaultSortOrder' => 1,
      'Items' => array(
        'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => '', 'Required' => true),
        'Description' => array('Type' => 'Text', 'Caption' => 'Popis', 'Default' => ''),
        'TimeCreate' => array('Type' => 'Date', 'Caption' => 'Datum zadání', 'Default' => '', 'Required' => true),
        'TimeDue' => array('Type' => 'Date', 'Caption' => 'Termín', 'Default' => '', 'Null' => true),
        'TimeClose' => array('Type' => 'Date', 'Caption' => 'Datum uzavření', 'Default' => '', 'Null' => true),
        'Priority' => array('Type' => 'TPriority', 'Caption' => 'Důležitost', 'Default' => 1),
        'Conclusion' => array('Type' => 'Text', 'Caption' => 'Vyhodnocení', 'Default' => ''),
        'Public' => array('Type' => 'Boolean', 'Caption' => 'Veřejné', 'Default' => '0'),
        'Progress' => array('Type' => 'Integer', 'Caption' => 'Průběh', 'Default' => '0', 'Suffix' => '%'),
        'Group' => array('Type' => 'TTaskGroup', 'Caption' => 'Kategorie', 'Default' => '', 'Null' => true),
        'AssignedTo' => array('Type' => 'TUser', 'Caption' => 'Přiřazeno', 'Default' => '', 'Null' => true),
        'Work' => array('Type' => 'TWorkListTask', 'Caption' => 'Práce', 'Default' => ''),
      ),
    ));
    $this->System->FormManager->RegisterClass('TaskGroup', array(
      'Title' => 'Kategorie úkolu',
      'Table' => 'TaskGroup',
      'DefaultSortColumn' => 'Name',
      'Items' => array(
        'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
        'Description' => array('Type' => 'Text', 'Caption' => 'Popis', 'Default' => ''),
        'Parent' => array('Type' => 'TTaskGroup', 'Caption' => 'Kategorie', 'Default' => '', 'Null' => true),
        'Tasks' => array('Type' => 'TTaskList', 'Caption' => 'Úkoly', 'Default' => ''),
      ),
    ));
    $this->System->FormManager->RegisterClass('Work', array(
      'Title' => 'Práce',
      'Table' => 'Work',
      'DefaultSortColumn' => 'TimeStart',
      'Items' => array(
        'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
        'Description' => array('Type' => 'Text', 'Caption' => 'Popis', 'Default' => ''),
        'TimeStart' => array('Type' => 'DateTime', 'Caption' => 'Čas začátku', 'Default' => ''),
        'Duration' => array('Type' => 'Float', 'Caption' => 'Trvání', 'Default' => '1', 'Suffix' => 'hodin'),
        'User' => array('Type' => 'TUser', 'Caption' => 'Uživatel', 'Default' => '1', 'Null' => true),
        'Task' => array('Type' => 'TTask', 'Caption' => 'Úkol', 'Default' => '', 'Null' => true),
      ),
    ));

  }
}
